import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.linear_model import LinearRegression

A = np.loadtxt( "d.txt" )
print ( A.shape )

A_entrena, A_prueba = train_test_split( A, random_state=21 )

print( A_entrena.shape ) 
print( A_prueba.shape ) 

# Construyo la matriz para el modelo de una línea recta
# Cada renglón de la matriz debe ser [xi, 1]

X_entrena = np.ones( A_entrena.shape )
X_entrena[:,0] = A_entrena[:,0]
y_entrena = A_entrena[:,1]

X_prueba = np.ones( A_prueba.shape )
X_prueba[:,0] = A_prueba[:,0]
y_prueba = A_prueba[:,1]

print( y_prueba.shape )
n, = y_prueba.shape

# Generamos el modelo de ajuste

modelo = LinearRegression( )
modelo.fit( X_entrena, y_entrena )

# Calculamos las mediciones RMS y R2
r2 = modelo.score( X_prueba, y_prueba )

vpredichas = modelo.predict( X_prueba )

error = y_prueba - vpredichas
rms = np.sqrt( np.sum(error.T * error)/n )

print( "R2:", r2 )
print( "ERROR RMS:", rms )

coef = modelo.coef_
a0 =  modelo.intercept_

print( coef )
print( a0 )

